import sys, struct, string
from types import *
from math import *

def calculate_acmr(indices, cache_size):
	cache = [0]*cache_size
	cache_ptr = 0
	cache_misses = 0
	for i in range(0, len(indices)):
		cache_hit = 0
		for j in range(0, cache_size):
			cache_hit |= (cache[j] == indices[i])
		if (cache_hit == 0):
			cache[cache_ptr] = indices[i]
			cache_ptr = (cache_ptr + 1) % cache_size
			cache_misses += 1
	return (cache_misses / (len(indices) / 3.0))

class triangle_data:
	added = 0
	score = 0.0
	verts = []
	def __init__(self):
        	self.verts = [0] * 3

class vertex_data:
	score = 0.0
	remaining_triangles = []

def optimize_vertex_cache_order(indices, cache_size):
	cache_score = [0.75] * (cache_size + 3)
	cache_idx = [-1] * (cache_size + 3)
	grow_cache_idx = [-1] * (cache_size + 3)
	
	if ((len(indices) < 3) or (len(indices) % 3 != 0) or (cache_size < 4)):
		return indices

	num_triangles = len(indices) / 3
	num_vertices = 0
	
	for i in range(0, len(indices)):
		if (indices[i] > num_vertices):
			num_vertices = indices[i]

	num_vertices += 1

	for i in range(3, cache_size):
		cache_score[i] = pow((cache_size - i) / (cache_size - 3.0), 1.5)

	for i in range(0, 3):
		cache_score[cache_size + i] = 0.0

	tris_left = num_triangles

	t = []
	v = []

	for i in range(0, num_triangles):
		t.append(triangle_data())

	for i in range(0, num_vertices):
		vd = vertex_data()
		vd.remaining_triangles = []
		v.append(vd)

	for i in range(0, num_triangles):
		t[i].added = 0
		t[i].score = 0.0
		t[i].verts[0] = indices[i * 3 + 0]
		t[i].verts[1] = indices[i * 3 + 1]
		t[i].verts[2] = indices[i * 3 + 2]
		vd = v[t[i].verts[0]]
		vd.remaining_triangles.append(i)
		vd = v[t[i].verts[1]]
		vd.remaining_triangles.append(i)
		vd = v[t[i].verts[2]]
		vd.remaining_triangles.append(i)

	for i in range(0, num_vertices):
		if (len(v[i].remaining_triangles) == 0):
			v[i].score = 1e10
		else:
			v[i].score = 2.0 * pow(len(v[i].remaining_triangles), -0.5)

	for i in range(0, num_triangles):
		t[i].score = v[t[i].verts[0]].score + v[t[i].verts[1]].score + v[t[i].verts[2]].score

	while (tris_left > 0):
		best_score = 0.0
		best_idx = -1
		for i in range(0, num_triangles):
			if ((t[i].added == 0) and (t[i].score > best_score)):
				best_score = t[i].score
				best_idx = i
		a = t[best_idx].verts[0]
		b = t[best_idx].verts[1]
		c = t[best_idx].verts[2]
		indices[(num_triangles - tris_left) * 3 + 0] = a
		indices[(num_triangles - tris_left) * 3 + 1] = b
		indices[(num_triangles - tris_left) * 3 + 2] = c

		for i in range(0, 3):
			v[t[best_idx].verts[i]].remaining_triangles.remove(best_idx)

		t[best_idx].added = 1
		tris_left -= 1
		grow_cache_idx[0] = a
		grow_cache_idx[1] = b
		grow_cache_idx[2] = c
		idx = 3
		for i in range(0, cache_size):
			grow_cache_idx[i + 3] = -1
			if ((cache_idx[i] != a) and (cache_idx[i] != b) and (cache_idx[i] != c)):
				grow_cache_idx[idx] = cache_idx[i]
				idx += 1
		cache_idx = grow_cache_idx
		for i in range(0, cache_size):
			if (cache_idx[i] >= 0):
				idx = cache_idx[i]
				old_score = v[idx].score
				if (len(v[idx].remaining_triangles) == 0):
					add = 1e10
				else:
					add = 2.0 * pow(len(v[idx].remaining_triangles), -0.5)
				new_score = cache_score[i] + add
				v[idx].score = new_score
				for j in range(0, len(v[idx].remaining_triangles)):
					t[v[idx].remaining_triangles[j]].score += new_score - old_score

	return indices

